// Simulation of the missile path
// A missile is fired in the angle al with the force F.
// Simulate its path.
// ----------------------------------------------------
exec SCIHOME/ScIntro.sce, mode(0)

nd=100;                  // number of steps of simulation
g=1;                     // gravitational acceleration
al=15;                   // angle of the shot
F=50;                    // force of the shot
fi=.99;                  // air resistance
Fx=F*cos(al*%pi/180);    // force decompositio - horizontal
Fy=F*sin(al*%pi/180);    // force decompositio - vertical

x=0; xt=x;               // initial position  - horizontal
y=0; yt=y;               // initial position  - vertical

// Loop of simulation
for t=1:nd
  Fx=fi*Fx;              // air resistance action on x-force
  x=x+Fx;                // horizontal coordinate of the missile
  Fy=Fy-g;               // gravitational action on y-force
  y=y+Fy;                // vertical coordinate of the missile
  xt=[xt x];             // storing
  yt=[yt y];             //   the missile path cordinates
end

// Resulta
j=find(yt<0); yt(j)=0;
plot(xt,yt,'linewidth',3)
set(gca(),'data_bounds',[0 2000 0 1200])
