// Prediction of daily traffic intnsity based on daily course
// - even if the order is always 1, the results are good 
// - model is based directly on deviations y from yf
// ----------------------------------------------------------
exec SCIHOME/ScIntro.sce, mode(0)

load _data/dataTunel.dat

// DATA CONSTRUCTION
y=dt(1,((3*288+1):35*288));
yy=[];
for k=([1 2 3 4 5  8 9 10 11 12  15 16 17 18 19  22 23 24 25 26]+2)
  yy=[yy; y(((k-1)*288+1):(k*288))];
end
yc=mean(yy,1);
yf=([yc(1:286) 0 0]+[yc(1:287) 0]+yc+[0 yc(1:287)]+[0 0 yc(1:286)])/5;
// choice of one specific daily intensity
nI=2;
y=y(nI*288:(nI+1)*288);

// ESTIMATION
V=[];
d(1)=0;
for t=2:288
  d(t)=y(t)-yf(t);
  Ps=[d(t) d(t-1) 1]';            // yf is filtered daily course
  V=V+Ps*Ps';
end
Vyp=V(2:$,1);
Vp=V(2:$,2:$);
th=inv(Vp)*Vyp

// PREDICTION
np=15;
for t=2:288-np
  di(t)=[d(t-1) 1]*th;            // first partial prediction
  for i=1:np
    di(t+i)=[di(t+i-1) 1]*th;   // successive predictions
  end
  yp(t+np)=yf(t+np)+di(t+np);                    // final value of prediction
end

// RESULTS
// prediction error variance
s=5:288;
e=y(s)-yp(s)';
SE=e*e'/288

// plot of y and its prediction
set(scf(),'position',[500 100 600 500])
plot(1:288,y(1:288),1:288,yp,1:288,yf,':')
legend('y','yp','yf');
