// Response to regression model 
//  with an external sinusoidal input signal variable
exec("ScIntro.sce",-1),mode(0)

N=100;                        // number of steps
       a1=.6;  a2=.2;  a3=-.4; // model parameters
b0=1;  b1=-.5; b2=.1;  b3=0;
k=2;
sd=.1;                             // < ------- DIFFERENCE FORM EQ.
ord=3;                        // model order
// construction of parameter vector for order 1,2,3
select ord
  case 1, th=[b0 a1 b1 k];
  case 2, th=[b0 a1 b1 a2 b2 k];
  case 3, th=[b0 a1 b1 a2 b2 a3 b3 k];
end
u=sin(10*(1:N)/N);            // input
y=zeros(1,N);                 // definition of output
y(1)=0;                       // inital condition
n1=ord+1;                     // starting time
for t=n1:N
  // construction of regression vectors for order 1,2,3
  select ord
    case 1, ps=[u(t) y(t-1) u(t-1) 1];
    case 2, ps=[u(t) y(t-1) u(t-1) y(t-2) u(t-2) 1];
    case 3, ps=[u(t) y(t-1) u(t-1) y(t-2) u(t-2) y(t-3) u(t-3) 1];
  end
  // simulation
  y(t)=th*ps'+sd*rand(1,1,'n');    // < ------- DIFFERENCE FORM EQ.
end

// RESULTS
s=n1:N;
plot(s,y(s),s,u(s))
set(gcf(),"position",[800 100 500 400])
