// One step prediction with known normal 1st order regression model
// - very very simple case - propagation trhough the model
// - for normal model nosise its covariance estimate can be evoluted
// - vary covariance r and compare the prediction results
exec("ScIntro.sce",-1),mode(0)

nd=160;                             // number of data
a1=.6; b0=1; r=.1;                // model parameters
u=1-.5*rand(1,nd,'norm');          // indut variable
yt=zeros(1,nd);
yp=zeros(1,nd);
rp=zeros(1,nd);

// SIMULATION AND PREDICTION LOOP
for t=2:nd                         // time loope
  yt(t)=a1*yp(t-1)+b0*u(t)+sqrt(r)*rand(1,1,'norm'); // output
  yp(t)=a1*yp(t-1)+b0*u(t);        // expectation evolution
  rp(t)=r+a1^2*rp(t-1);            // noise vaiance evolution
end

// Results
printf('\nVariances: (simulated, computed, estimated, realired)\n\n')
printf('Var_e_sim =      %g\n',r)
printf('Var_e_comp =     %g\n',r*(1+a1^2))
printf('Var_e_est =      %g\n',rp($))
printf('Var_e_realized = %g\n',sum((yt-yp).^2)/nd)

plot(1:nd,yt,'b',1:nd,yp,'r.:')     // outp. and predic.
set(gcf(),'position',[500 100 600 500])
set(gca(),"data_bounds",[1 nd -1 5])
legend('output','prediction');
title('Data and prediction')  
